OSDN Git Service

[update] : Added latest mkinitcpio-archiso
authorhayao <hayao@fascode.net>
Wed, 8 Sep 2021 03:03:23 +0000 (12:03 +0900)
committerhayao <hayao@fascode.net>
Wed, 8 Sep 2021 03:03:23 +0000 (12:03 +0900)
13 files changed:
system/initcpio/archiso_shutdown [deleted file]
system/initcpio/hooks/archiso
system/initcpio/hooks/archiso_loop_mnt
system/initcpio/hooks/archiso_pxe_common
system/initcpio/hooks/archiso_pxe_http
system/initcpio/hooks/archiso_pxe_nbd
system/initcpio/install/archiso
system/initcpio/install/archiso_kms
system/initcpio/install/archiso_loop_mnt
system/initcpio/install/archiso_pxe_common
system/initcpio/install/archiso_pxe_http
system/initcpio/install/archiso_pxe_nbd
system/initcpio/script/archiso_shutdown

diff --git a/system/initcpio/archiso_shutdown b/system/initcpio/archiso_shutdown
deleted file mode 100755 (executable)
index 4a0c7dc..0000000
+++ /dev/null
@@ -1,39 +0,0 @@
-#!/bin/ash
-
-# /oldroot depends on things inside /oldroot/run/archiso...
-mkdir /oldrun
-mount -n --move /oldroot/run /oldrun
-
-# Unmount all mounts now.
-umount "$(mount | awk '$3 ~/^\/oldroot/ {print $3}' | sort -r)"
-
-# Remove all dm-snapshot devices.
-dmsetup remove_all
-
-# Remove all loopback devices.
-for _lup in $(grep ^/dev/loop /oldrun/archiso/used_block_devices | tac); do
-    if ! losetup -d -- "${_lup}" 2> /dev/null; then
-        umount -d -- "${_lup}"
-    fi
-done
-
-# Unmount the space used to store *.cow.
-umount /oldrun/archiso/cowspace
-
-# Unmount boot device if needed (no copytoram=y used)
-if [ ! -d /oldrun/archiso/copytoram ]; then
-    if [ -d /oldrun/archiso/img_dev ]; then
-        umount /oldrun/archiso/img_dev
-    else
-        umount /oldrun/archiso/bootmnt
-    fi
-fi
-
-# reboot / poweroff / halt, depending on the argument passed by init
-# if something invalid is passed, we halt
-case "$1" in
-  reboot|poweroff|halt) "$1" -f ;;
-  *) halt -f;;
-esac
-
-# vim: set ft=sh:
index e091b8e..742fbbf 100644 (file)
@@ -7,13 +7,13 @@ _mnt_dmsnapshot() {
     local img="${1}"
     local newroot="${2}"
     local mnt="${3}"
-    local img_fullname="${img##*/}";
+    local img_fullname="${img##*/}"
     local img_name="${img_fullname%%.*}"
     local dm_snap_name="${dm_snap_prefix}_${img_name}"
     local ro_dev ro_dev_size rw_dev
 
     ro_dev="$(losetup --find --show --read-only -- "${img}")"
-    echo "${ro_dev}" >> /run/archiso/used_block_devices
+    printf '%s\n' "${ro_dev}" >>/run/archiso/used_block_devices
     ro_dev_size="$(blockdev --getsz "${ro_dev}")"
 
     if [ "${cow_persistent}" = "P" ]; then
@@ -33,7 +33,7 @@ _mnt_dmsnapshot() {
     fi
 
     rw_dev="$(losetup --find --show "/run/archiso/cowspace/${cow_directory}/${img_name}.cow")"
-    echo "${rw_dev}" >> /run/archiso/used_block_devices
+    printf '%s\n' "${rw_dev}" >>/run/archiso/used_block_devices
 
     dmsetup create "${dm_snap_name}" --table \
         "0 ${ro_dev_size} snapshot ${ro_dev} ${rw_dev} ${cow_persistent} ${cow_chunksize}"
@@ -43,7 +43,7 @@ _mnt_dmsnapshot() {
     fi
 
     _mnt_dev "/dev/mapper/${dm_snap_name}" "${newroot}${mnt}" "-w" "defaults"
-    readlink -f "/dev/mapper/${dm_snap_name}" >> /run/archiso/used_block_devices
+    readlink -f "/dev/mapper/${dm_snap_name}" >>/run/archiso/used_block_devices
 }
 
 # args: source, newroot, mountpoint
@@ -53,11 +53,10 @@ _mnt_overlayfs() {
     local mnt="${3}"
     mkdir -p "/run/archiso/cowspace/${cow_directory}/upperdir" "/run/archiso/cowspace/${cow_directory}/workdir"
     mount -t overlay -o \
-    "lowerdir=${src},upperdir=/run/archiso/cowspace/${cow_directory}/upperdir,workdir=/run/archiso/cowspace/${cow_directory}/workdir" \
-    airootfs "${newroot}${mnt}"
+        "lowerdir=${src},upperdir=/run/archiso/cowspace/${cow_directory}/upperdir,workdir=/run/archiso/cowspace/${cow_directory}/workdir" \
+        airootfs "${newroot}${mnt}"
 }
 
-
 # args: /path/to/image_file, mountpoint
 _mnt_sfs() {
     local img="${1}"
@@ -69,24 +68,61 @@ _mnt_sfs() {
     # defined via initcpio's parse_cmdline()
     if [ "${copytoram}" = "y" ]; then
         msg -n ":: Copying squashfs image to RAM..."
-        if ! cp -- "${img}" "/run/archiso/copytoram/${img_fullname}" ; then
+
+        # in case we have pv use it to display copy progress feedback otherwise
+        # fallback to using plain cp
+        if command -v pv >/dev/null 2>&1; then
+            echo ""
+            (pv "${img}" >"/run/archiso/copytoram/${img_fullname}")
+            local rc=$?
+        else
+            (cp -- "${img}" "/run/archiso/copytoram/${img_fullname}")
+            local rc=$?
+        fi
+
+        if [ $rc != 0 ]; then
             echo "ERROR: while copy '${img}' to '/run/archiso/copytoram/${img_fullname}'"
             launch_interactive_shell
         fi
+
         img="/run/archiso/copytoram/${img_fullname}"
         msg "done."
     fi
     sfs_dev="$(losetup --find --show --read-only -- "${img}")"
-    echo "${sfs_dev}" >> /run/archiso/used_block_devices
+    echo "${sfs_dev}" >>/run/archiso/used_block_devices
     _mnt_dev "${sfs_dev}" "${mnt}" "-r" "defaults"
 }
 
+# args: /path/to/image_file, mountpoint
+_mnt_erofs() {
+    local img="${1}"
+    local mnt="${2}"
+    local img_fullname="${img##*/}"
+    local erofs_dev
+
+    # shellcheck disable=SC2154
+    # defined via initcpio's parse_cmdline()
+    if [ "${copytoram}" = "y" ]; then
+        msg -n ":: Copying EROFS image to RAM..."
+        if ! cp -- "${img}" "/run/archiso/copytoram/${img_fullname}"; then
+            echo "ERROR: while copy '${img}' to '/run/archiso/copytoram/${img_fullname}'"
+            launch_interactive_shell
+        fi
+        img="/run/archiso/copytoram/${img_fullname}"
+        msg "done."
+    fi
+    erofs_dev="$(losetup --find --show --read-only -- "${img}")"
+    echo "${erofs_dev}" >>/run/archiso/used_block_devices
+    _mnt_dev "${erofs_dev}" "${mnt}" "-r" "defaults" "erofs"
+}
+
 # args: device, mountpoint, flags, opts
 _mnt_dev() {
     local dev="${1}"
     local mnt="${2}"
     local flg="${3}"
     local opts="${4}"
+    local fstype="${5:-auto}"
 
     mkdir -p "${mnt}"
 
@@ -99,7 +135,7 @@ _mnt_dev() {
         launch_interactive_shell
     done
 
-    if mount -o "${opts}" "${flg}" "${dev}" "${mnt}"; then
+    if mount -t "${fstype}" -o "${opts}" "${flg}" "${dev}" "${mnt}"; then
         msg ":: Device '${dev}' mounted successfully."
     else
         echo "ERROR; Failed to mount '${dev}'"
@@ -112,7 +148,7 @@ _mnt_dev() {
 _verify_checksum() {
     local _status
     cd "/run/archiso/bootmnt/${archisobasedir}/${arch}" || exit 1
-    sha512sum -c airootfs.sha512 > /tmp/checksum.log 2>&1
+    sha512sum -c airootfs.sha512 >/tmp/checksum.log 2>&1
     _status=$?
     cd -- "${OLDPWD}" || exit 1
     return "${_status}"
@@ -120,8 +156,9 @@ _verify_checksum() {
 
 _verify_signature() {
     local _status
+    local sigfile="${1}"
     cd "/run/archiso/bootmnt/${archisobasedir}/${arch}" || exit 1
-    gpg --homedir /gpg --status-fd 1 --verify airootfs.sfs.sig 2>/dev/null | grep -qE '^\[GNUPG:\] GOODSIG'
+    gpg --homedir /gpg --status-fd 1 --verify "${sigfile}" 2>/dev/null | grep -qE '^\[GNUPG:\] GOODSIG'
     _status=$?
     cd -- "${OLDPWD}" || exit 1
     return ${_status}
@@ -135,8 +172,7 @@ run_hook() {
     # shellcheck disable=SC2154
     # defined via initcpio's parse_cmdline()
     [ -z "${archisodevice}" ] && archisodevice="/dev/disk/by-label/${archisolabel}"
-    #[ -z "${cow_spacesize}" ] && cow_spacesize="256M"
-    [ -z "${cow_spacesize}" ] && cow_spacesize="%COWSPACE%"
+    [ -z "${cow_spacesize}" ] && cow_spacesize="256M"
     # shellcheck disable=SC2154
     # defined via initcpio's parse_cmdline()
     if [ -n "${cow_label}" ]; then
@@ -161,11 +197,12 @@ run_hook() {
 # args: /path/to/newroot
 archiso_mount_handler() {
     local newroot="${1}"
+    local sigfile
 
     if ! mountpoint -q "/run/archiso/bootmnt"; then
         _mnt_dev "${archisodevice}" "/run/archiso/bootmnt" "-r" "defaults"
         if [ "${copytoram}" != "y" ]; then
-            readlink -f "${archisodevice}" >> /run/archiso/used_block_devices
+            readlink -f "${archisodevice}" >>/run/archiso/used_block_devices
         fi
     fi
 
@@ -191,15 +228,20 @@ archiso_mount_handler() {
     # defined via initcpio's parse_cmdline()
     if [ "${verify}" = "y" ]; then
         if [ -f "/run/archiso/bootmnt/${archisobasedir}/${arch}/airootfs.sfs.sig" ]; then
+            sigfile="airootfs.sfs.sig"
+        elif [ -f "/run/archiso/bootmnt/${archisobasedir}/${arch}/airootfs.erofs.sig" ]; then
+            sigfile="airootfs.erofs.sig"
+        fi
+        if [ -n "${sigfile}" ]; then
             msg -n ":: Signature verification requested, please wait..."
-            if _verify_signature; then
+            if _verify_signature "${sigfile}"; then
                 msg "done. Signature is OK, continue booting."
             else
                 echo "ERROR: one or more files are corrupted"
                 launch_interactive_shell
             fi
         else
-            echo "ERROR: verify=y option specified but ${archisobasedir}/${arch}/airootfs.sfs.sig not found"
+            echo "ERROR: verify=y option specified but GPG signature not found in ${archisobasedir}/${arch}/"
             launch_interactive_shell
         fi
     fi
@@ -212,7 +254,7 @@ archiso_mount_handler() {
 
     if [ -n "${cow_device}" ]; then
         _mnt_dev "${cow_device}" "/run/archiso/cowspace" "-r" "${cow_flags}"
-        readlink -f "${cow_device}" >> /run/archiso/used_block_devices
+        readlink -f "${cow_device}" >>/run/archiso/used_block_devices
         mount -o remount,rw "/run/archiso/cowspace"
     else
         msg ":: Mounting /run/archiso/cowspace (tmpfs) filesystem, size=${cow_spacesize}..."
@@ -222,15 +264,20 @@ archiso_mount_handler() {
     mkdir -p "/run/archiso/cowspace/${cow_directory}"
     chmod 0700 "/run/archiso/cowspace/${cow_directory}"
 
-    _mnt_sfs "/run/archiso/bootmnt/${archisobasedir}/${arch}/airootfs.sfs" "/run/archiso/sfs/airootfs"
-    if [ -f "/run/archiso/sfs/airootfs/airootfs.img" ]; then
-        _mnt_dmsnapshot "/run/archiso/sfs/airootfs/airootfs.img" "${newroot}" "/"
+    if [ -f "/run/archiso/bootmnt/${archisobasedir}/${arch}/airootfs.sfs" ]; then
+        _mnt_sfs "/run/archiso/bootmnt/${archisobasedir}/${arch}/airootfs.sfs" "/run/archiso/airootfs"
+    elif [ -f "/run/archiso/bootmnt/${archisobasedir}/${arch}/airootfs.erofs" ]; then
+        _mnt_erofs "/run/archiso/bootmnt/${archisobasedir}/${arch}/airootfs.erofs" "/run/archiso/airootfs"
+    fi
+    if [ -f "/run/archiso/airootfs/airootfs.img" ]; then
+        _mnt_dmsnapshot "/run/archiso/airootfs/airootfs.img" "${newroot}" "/"
     else
-        _mnt_overlayfs "/run/archiso/sfs/airootfs" "${newroot}" "/"
+        _mnt_overlayfs "/run/archiso/airootfs" "${newroot}" "/"
     fi
 
     if [ "${copytoram}" = "y" ]; then
         umount -d /run/archiso/bootmnt
+        rmdir /run/archiso/bootmnt
     fi
 }
 
index 41899e4..a5a71e8 100644 (file)
@@ -2,7 +2,7 @@
 #
 # SPDX-License-Identifier: GPL-3.0-or-later
 
-run_hook () {
+run_hook() {
     # shellcheck disable=SC2154
     # defined via initcpio's parse_cmdline()
     [ -n "${img_label}" ] && img_dev="/dev/disk/by-label/${img_label}"
@@ -14,7 +14,7 @@ run_hook () {
     fi
 }
 
-archiso_loop_mount_handler () {
+archiso_loop_mount_handler() {
     newroot="${1}"
 
     local _dev_loop
@@ -24,7 +24,7 @@ archiso_loop_mount_handler () {
     # shellcheck disable=SC2154
     # defined via initcpio's parse_cmdline()
     if [ "${copytoram}" != "y" ]; then
-        readlink -f "${img_dev}" >> /run/archiso/used_block_devices
+        readlink -f "${img_dev}" >>/run/archiso/used_block_devices
     fi
 
     if _dev_loop=$(losetup --find --show --read-only "/run/archiso/img_dev/${img_loop}"); then
index a47b6c0..6cadc34 100644 (file)
@@ -2,7 +2,7 @@
 #
 # SPDX-License-Identifier: GPL-3.0-or-later
 
-run_hook () {
+run_hook() {
     # Do *not* declare 'bootif_dev' local! We need it in run_latehook().
     local i net_mac bootif_mac
     local DNSDOMAIN HOSTNAME IPV4DNS0 IPV4DNS1 ROOTSERVER
@@ -13,11 +13,11 @@ run_hook () {
     if [ -n "${ip}" ]; then
         if [ -n "${BOOTIF}" ]; then
             bootif_mac="${BOOTIF#01-}"
-            # shellcheck disable=SC2169
+            # shellcheck disable=SC2169,SC3060
             # ash supports bash-like string replacment
             bootif_mac="${bootif_mac//-/:}"
             for i in /sys/class/net/*/address; do
-                read -r net_mac < "${i}"
+                read -r net_mac <"${i}"
                 if [ "${bootif_mac}" = "${net_mac}" ]; then
                     bootif_dev=${i#/sys/class/net/}
                     bootif_dev=${bootif_dev%/address}
@@ -47,20 +47,20 @@ run_hook () {
 
         # setup DNS resolver
         if [ "${IPV4DNS0}" != "0.0.0.0" ]; then
-            echo "# added by archiso_pxe_common hook" > /etc/resolv.conf
-            echo "nameserver ${IPV4DNS0}" >> /etc/resolv.conf
+            echo "# added by archiso_pxe_common hook" >/etc/resolv.conf
+            echo "nameserver ${IPV4DNS0}" >>/etc/resolv.conf
         fi
         if [ "${IPV4DNS1}" != "0.0.0.0" ]; then
-            echo "nameserver ${IPV4DNS1}" >> /etc/resolv.conf
+            echo "nameserver ${IPV4DNS1}" >>/etc/resolv.conf
         fi
         if [ -n "${DNSDOMAIN}" ]; then
-            echo "search ${DNSDOMAIN}" >> /etc/resolv.conf
-            echo "domain ${DNSDOMAIN}" >> /etc/resolv.conf
+            echo "search ${DNSDOMAIN}" >>/etc/resolv.conf
+            echo "domain ${DNSDOMAIN}" >>/etc/resolv.conf
         fi
     fi
 }
 
-run_latehook () {
+run_latehook() {
     if [ -n "${ip}" ]; then
         [ -z "${copy_resolvconf}" ] && copy_resolvconf="y"
 
@@ -73,8 +73,8 @@ run_latehook () {
                 ip link set "${netdev}" down
             done
         elif [ "${copy_resolvconf}" != "n" ] && [ -f /etc/resolv.conf ]; then
-            rm -f /new_root/etc/resolv.conf
-            cp /etc/resolv.conf /new_root/etc/resolv.conf
+            rm -f -- /new_root/etc/resolv.conf
+            cp -- /etc/resolv.conf /new_root/etc/resolv.conf
         fi
     fi
 }
index efae923..db75703 100644 (file)
@@ -37,8 +37,9 @@ _curl_get() {
     fi
 }
 
-archiso_pxe_http_mount_handler () {
+archiso_pxe_http_mount_handler() {
     newroot="${1}"
+    local img_type="sfs"
 
     msg ":: Mounting /run/archiso/httpspace (tmpfs) filesystem, size='${archiso_http_spc}'"
     mkdir -p "/run/archiso/httpspace"
@@ -46,7 +47,12 @@ archiso_pxe_http_mount_handler () {
 
     # shellcheck disable=SC2154
     # defined via initcpio's parse_cmdline()
-    _curl_get "${archiso_http_srv}${archisobasedir}/${arch}/airootfs.sfs" "/${arch}"
+    if ! curl -L -f -o /dev/null -s -r 0-0 "${archiso_http_srv}${archisobasedir}/${arch}/airootfs.sfs"; then
+        if curl -L -f -o /dev/null -s -r 0-0 "${archiso_http_srv}${archisobasedir}/${arch}/airootfs.erofs"; then
+            img_type="erofs"
+        fi
+    fi
+    _curl_get "${archiso_http_srv}${archisobasedir}/${arch}/airootfs.${img_type}" "/${arch}"
 
     # shellcheck disable=SC2154
     # defined via initcpio's parse_cmdline()
@@ -56,7 +62,7 @@ archiso_pxe_http_mount_handler () {
     # shellcheck disable=SC2154
     # defined via initcpio's parse_cmdline()
     if [ "${verify}" = "y" ]; then
-        _curl_get "${archiso_http_srv}${archisobasedir}/${arch}/airootfs.sfs.sig" "/${arch}"
+        _curl_get "${archiso_http_srv}${archisobasedir}/${arch}/airootfs.${img_type}.sig" "/${arch}"
     fi
 
     mkdir -p "/run/archiso/bootmnt"
index 8ac44e7..2e363d9 100644 (file)
@@ -7,7 +7,7 @@ run_earlyhook() {
     # defined via initcpio's parse_cmdline()
     if [ -n "${ip}" ] && [ -n "${archiso_nbd_srv}" ]; then
         # Module autoloading like with loop devices does not work, doing manually...
-        modprobe nbd 2> /dev/null
+        modprobe nbd 2>/dev/null
     fi
 }
 
@@ -21,7 +21,7 @@ run_hook() {
     fi
 }
 
-archiso_pxe_nbd_mount_handler () {
+archiso_pxe_nbd_mount_handler() {
     newroot="${1}"
 
     msg ":: Waiting for boot device..."
index 74948c7..d04e04f 100644 (file)
@@ -19,12 +19,18 @@ build() {
     add_binary gpg
     add_binary grep
 
+    if command -v pv >/dev/null 2>&1; then
+        add_binary pv
+    else
+        warning 'pv not found; falling back to cp for copy to RAM'
+    fi
+
     add_file /usr/lib/udev/rules.d/60-cdrom_id.rules
     add_file /usr/lib/udev/rules.d/10-dm.rules
     add_file /usr/lib/udev/rules.d/95-dm-notify.rules
     add_file /usr/lib/initcpio/udev/11-dm-initramfs.rules /usr/lib/udev/rules.d/11-dm-initramfs.rules
     if [[ $ARCHISO_GNUPG_FD ]]; then
         mkdir -m 0700 -- "$BUILDROOT/gpg"
-        gpg --homedir "$BUILDROOT/gpg" --import <& "$ARCHISO_GNUPG_FD"
+        gpg --homedir "$BUILDROOT/gpg" --import <&"$ARCHISO_GNUPG_FD"
     fi
 }
index 8129127..018f574 100644 (file)
@@ -24,7 +24,7 @@ build() {
 }
 
 help() {
-    cat << HELPEOF
+    cat <<HELPEOF
 Adds all common KMS drivers to the initramfs image.
 HELPEOF
 }
index 1f2c529..f0fed76 100644 (file)
@@ -7,7 +7,7 @@ build() {
 }
 
 help() {
-cat<<HELPEOF
+    cat <<HELPEOF
   This hook loads the necessary modules for boot via loop device.
 HELPEOF
 }
index 458fa69..ad96c32 100644 (file)
@@ -16,11 +16,11 @@ build() {
     add_binary "$(readlink -f /usr/lib/libnss_dns.so.2)"
 
     add_dir /etc
-    echo "hosts: files dns" > "$BUILDROOT/etc/nsswitch.conf"
+    printf "hosts: files dns\n" >"$BUILDROOT/etc/nsswitch.conf"
 }
 
 help() {
-cat<<HELPEOF
+    cat <<HELPEOF
   This hook loads the necessary modules for boot via PXE.
 HELPEOF
 }
index 1e80852..afdde43 100644 (file)
@@ -11,7 +11,7 @@ build() {
 }
 
 help() {
-cat<<HELPEOF
+    cat <<HELPEOF
   This hook loads the necessary modules for boot via PXE and HTTP.
 HELPEOF
 }
index b4fb3b6..2d19f0e 100644 (file)
@@ -11,7 +11,7 @@ build() {
 }
 
 help() {
-cat<<HELPEOF
+    cat <<HELPEOF
   This hook loads the necessary modules for boot via PXE and NBD.
 HELPEOF
 }
index 23a8a79..dd3bb96 100644 (file)
@@ -14,7 +14,7 @@ dmsetup remove_all
 
 # Remove all loopback devices.
 for _lup in $(grep ^/dev/loop /oldrun/archiso/used_block_devices | tac); do
-    if ! losetup -d -- "${_lup}" 2> /dev/null; then
+    if ! losetup -d -- "${_lup}" 2>/dev/null; then
         umount -d -- "${_lup}"
     fi
 done
@@ -34,8 +34,8 @@ fi
 # reboot / poweroff / halt, depending on the argument passed by init
 # if something invalid is passed, we halt
 case "$1" in
-  reboot|poweroff|halt) "$1" -f ;;
-  *) halt -f;;
+reboot | poweroff | halt) "$1" -f ;;
+*) halt -f ;;
 esac
 
 # vim: set ft=sh: